import { CosmWasmClient, IndexedTx } from "@cosmjs/cosmwasm-stargate";
import { ChainName, GatewayTransferMsg, GatewayTransferWithPayloadMsg, TokenId, WormholeMessageId } from "@wormhole-foundation/connect-sdk";
import { CosmwasmAddress } from "./address";
import { CosmwasmChainName } from "./types";
import { CosmwasmIbcBridge } from "./protocols/ibc";
import { CosmwasmTokenBridge } from "./protocols/tokenBridge";
export declare module Gateway {
    const name: "Wormchain";
    function gatewayAddress(): string;
    function tokenBridgeAddress(): string;
    function coreAddress(): string;
    function getRpc(): Promise<CosmWasmClient>;
    function getTokenBridge(rpc?: CosmWasmClient): Promise<CosmwasmTokenBridge>;
    function getIbcBridge(rpc?: CosmWasmClient): Promise<CosmwasmIbcBridge>;
    function getWrappedAsset(token: TokenId): Promise<CosmwasmAddress>;
    function getGatewaySourceChannel(chain: CosmwasmChainName): string;
    function deriveIbcDenom(chain: CosmwasmChainName, denom: string): CosmwasmAddress;
    function makeTransferMsg(chain: ChainName, recipient: CosmwasmAddress, fee?: bigint, payload?: string, nonce?: number): GatewayTransferWithPayloadMsg | GatewayTransferMsg;
    function parseWormholeMessage(tx: IndexedTx): WormholeMessageId;
}
//# sourceMappingURL=gateway.d.ts.map