import { CosmWasmClient } from "@cosmjs/cosmwasm-stargate";
import { ChainAddress, ChainName, GatewayTransferMsg, GatewayTransferWithPayloadMsg, IbcBridge, IbcMessageId, IbcTransferInfo, Network, TxHash, WormholeMessageId } from "@wormhole-foundation/connect-sdk";
import { CosmwasmContracts } from "../contracts";
import { CosmwasmChainName, AnyCosmwasmAddress } from "../types";
import { CosmwasmUnsignedTransaction } from "../unsignedTransaction";
export declare class CosmwasmIbcBridge implements IbcBridge<"Cosmwasm"> {
    readonly network: Network;
    readonly chain: CosmwasmChainName;
    readonly rpc: CosmWasmClient;
    readonly contracts: CosmwasmContracts;
    private gatewayAddress;
    private channelToChain;
    private chainToChannel;
    private constructor();
    static fromProvider(rpc: CosmWasmClient, contracts: CosmwasmContracts): Promise<CosmwasmIbcBridge>;
    getTransferChannel(chain: ChainName): string | null;
    transfer(sender: AnyCosmwasmAddress, recipient: ChainAddress, token: AnyCosmwasmAddress | "native", amount: bigint): AsyncGenerator<CosmwasmUnsignedTransaction>;
    lookupTransferFromTx(txid: TxHash): Promise<IbcTransferInfo>;
    lookupMessageFromIbcMsgId(msg: IbcMessageId): Promise<WormholeMessageId | null>;
    private lookupTxFromIbcMsgId;
    lookupTransferFromIbcMsgId(msg: IbcMessageId): Promise<IbcTransferInfo>;
    lookupTransferFromMsg(msg: GatewayTransferMsg | GatewayTransferWithPayloadMsg): Promise<IbcTransferInfo>;
    private parseIbcTransferInfo;
    private fetchTransferInfo;
    fetchTransferChannel(chain: CosmwasmChainName): Promise<string>;
    private createUnsignedTx;
}
//# sourceMappingURL=ibc.d.ts.map